// JavaScript Document

array = []
tree = []
tree2 = []
function getCode(){
	var code = document.getElementById("codeArea").value
	return compile(code)
}

//We need to completely reorganize this code
//We need a createNode(node) function instead of the actual clone one
//FIX After and before shouldnt be arrays, just objects
//FIX after text disappears when adding --> 1+2
//Add support for return. It should be treated as a function call --> return asdf = return(asdf)
//Add suport for comments /* */ and //
function compile(text){
	//Divide the code into lines by using returns.
	array=text.split(/\n/)
	
	//Keep the level of indentation of each line & delete blank lines
	newArray = []
	var bracketIndexes = []
	for(var i=0,index=0 ; i<array.length ; i++){
		if(array[i].trim()!=""){ //Only if line is not blank
			newArray[index]={}
			newArray[index].originalLine=i+1 //Keep the number of the original line for future error exceptions
			indentation = array[i].match(/\t/g) //Count the number of tabs at the beginning of the line
			if (indentation==null){ //If no tabs
				newArray[index].indentation = 0
			}
			else{
				newArray[index].indentation = indentation.length
			}
			newArray[index].text=array[i].trim() //Erase spaces at both ends of the line
			index++
		}
	}
	array = newArray
	delete newArray
	
	//Convert indentation into a syntax tree
	tree2 = recursiveTabs(0,array)
	delete array
	
	//Convert that syntax tree into an abstract syntax tree by analyzing its lines
	tree2 = recursiveSyntaxAnalyzer(tree2)
	return tree2
}

//Recursive tabs converts an array into a syntax tree given its indentation using recursion
////Because of recursion, it will throw an error if you used more than 13925 (number may vary) nested statements.
////Though if you are using 13926 nested statements you probably have bigger problems :)

var indexTabs = 0
function recursiveTabs(indentation,array){
	var container = []
	while(indexTabs<array.length){
		// We preevaluate the if conditions as recursion might change some of its values
		var evaluation	
		if(array[indexTabs].indentation>indentation==true){evaluation=0}
		if(array[indexTabs].indentation==indentation==true){evaluation=1}
		if(array[indexTabs].indentation<indentation==true){evaluation=2}
		if(evaluation==0){ //More indentation, recursion
			//Anything with more indentation should be a child of what we had before
			container[container.length-1].children = recursiveTabs(array[indexTabs].indentation,array)
		}
		if(evaluation==1){ //Same indentation, just add to array and keep going
			container.push(array[indexTabs])
			container[container.length-1].children = [] //No children
			indexTabs++
		}
		if(evaluation==2){ //Less indentation, return
			return container
		}
	}
	// Array ended, return the tree
	return container
}

function recursiveSyntaxAnalyzer(tree){
	for(var i=0;i<tree.length;i++){ //Analyze every line
		//We should cache tree[i] into a variable, future.
		
		//FOR 
		if(tree[i].text.match(/^for\s*\(/)){ //Matches the word for followed by either a space or a bracket
			tree[i].type="for"
			tree[i].text=tree[i].text.replace('for','').trim() //Remove the keyword for
			forParts = divideStatements(tree[i].text,";",true,false,false)
			if(forParts.length==3 || forParts.length==4){
				//Create the object initialization
				tree[i].initialization = tree[i].clone()
				tree[i].initialization.children = []	
				tree[i].initialization.text = forParts[0].trim().substring(1) //Substring removes the first opening bracket (		
				//Create the object condition
				tree[i].condition = tree[i].clone()
				tree[i].condition.children = []
				tree[i].condition.text = forParts[1].trim()
				//Create the object afterthought
				tree[i].afterthought = tree[i].clone()
				tree[i].afterthought.children = []
				tree[i].afterthought.text = forParts[2].trim()
				
				if(forParts.length==4 && forParts[3].trim()!=""){ //There's text after the loop (one line loop)
					if(tree[i].children.length==0){
						tree[i].children[0] = {}
						tree[i].children[0].text = forParts[3].trim()
						tree[i].children[0].indentation = tree[i].indentation+1
						tree[i].children[0].originalLine = tree[i].originalLine
						tree[i].children[0].children = []
					}
					else{throwError(tree[i].originalLine,2)} //ERROR 2
				}
				tree[i].text = ""//Erase the text
			}
			else{
				if(forParts.length>4){throwError(tree[i].originalLine,1)} //ERROR 1
				if(forParts.length<4){throwError(tree[i].originalLine,3)} //ERROR 3
			}
			//Divide with commas , and parse the initialization, condition and afterthought too
			var initalizationArray = divideStatements(tree[i].initialization.text,",",true,false,false)
			tree[i].condition =  [tree[i].condition] //Condition cannot have commas, no need to parse it
			var afterthoughtArray = divideStatements(tree[i].afterthought.text,",",true,false,false)
			var baseNode = tree[i].initialization.clone() //We need to clone it back afterwards
			//Initialitation, condition and afterthought are arrays
			tree[i].initialization = []
			tree[i].afterthought = []
			for(var l=0;l<initalizationArray.length;l++){
				tree[i].initialization[l] = baseNode.clone()
				delete tree[i].initialization[l].type //We don't want to copy the type too
				tree[i].initialization[l].text = initalizationArray[l]
				tree[i].initialization[l] = recursiveSyntaxAnalyzer([tree[i].initialization[l]])[0] //Parse it too
			}
			delete tree[i].condition[0].type //We don't want to copy the type too
			delete tree[i].condition[0].initialization //We don't want to copy this either
			tree[i].condition[0] = recursiveSyntaxAnalyzer([tree[i].condition[0]])[0]
			for(var l=0;l<afterthoughtArray.length;l++){
				tree[i].afterthought[l] = baseNode.clone()
				delete tree[i].afterthought[l].type //We don't want to copy the type too
				tree[i].afterthought[l].text = afterthoughtArray[l]
				tree[i].afterthought[l] = recursiveSyntaxAnalyzer([tree[i].afterthought[l]])[0] //Parse it too
			}
			continue;
		}
		
		//WHILE We'll add this later
		if(false){
			
		}
		
		//DO We'll add this later
		if(false){
			
		}
		
		//Divide lines with semicolons ;
		if(tree[i].text.indexOf(';')!=-1){ //Only check if there are semicollons ;
			var lineParts = divideStatements(tree[i].text,";",false,false,false)
			if(lineParts.length!=1){ //The line was divided
				for(var l=lineParts.length-1;l>-1;l--){
					tree.splice(i+1,0,{
						indentation: tree[i].indentation,
						originalLine: tree[i].originalLine,
						children: tree[i].children,
						text: lineParts[l].trim()
					}) //Add a new node to the tree
				}
				tree.splice(i,1)  //Delete the original node
				i--
				continue;
			}		
		}
		
		//Function definition or function call
		if(tree[i].text.match(/^[a-zA-Z]\w*\s*\(/)){
			//Check if anything follows the function (function definition)
			tree[i].funcName = tree[i].text.substring(0,tree[i].text.indexOf("(")) //First opening bracket indicates the end of the function name
			var argumentParts = divideStatements(tree[i].text.substring(tree[i].text.indexOf("(")),",",true,false,false) //Get the arguments
			argumentParts[0]=argumentParts[0].substring(1) //Erase the extra bracket
			if(argumentParts[argumentParts.length-1]=="" && tree[i].children.length==0){ //No function definition == call to function
				tree[i].type = "funcCall"
			}
			else{
				tree[i].type = "funcDefinition"
				if(afterBrackets && tree[i].children.length!=0){ //ERROR 4
					throwError(tree[i].originalLine,4,[tree[i].funcName])	
				}
				else if(afterBrackets){
					tree[i].children[0] = tree[i].clone()
					tree[i].children[0].text = argumentParts[argumentParts.length-1].trim()
					tree[i].children[0].indentation += 1
					tree[i].children[0].children = [] //We don't want to copy the children too
					delete tree[i].children[0].type //We don't want to copy the type too
					argumentParts = argumentParts.splice(0,argumentParts.length-1) //Delete the function definition so that it is not confused with an argument
				}
			}
			delete tree[i].text
			tree[i].arguments = []
			for (var z=0;z<argumentParts.length;z++){
				tree[i].arguments[z] = tree[i].clone()
				tree[i].arguments[z].children = [] //We don't want to copy the children too
				delete tree[i].arguments[z].type //We don't want to copy the type too
				delete tree[i].arguments[z].funcName //We don't want to copy the name too
				delete tree[i].arguments[z].arguments //We don't want to copy the arguments too
				tree[i].arguments[z].text = argumentParts[z]
			}
			continue;
		}

		//Array definition
		if(tree[i].text[0] == '[' && tree[i].text[tree[i].text.length-1] == ']'){ 
            var divided = divideStatements(tree[i].text.substring(1,tree[i].text.length-1),",",true,false,false)
			tree[i].children = []
			tree[i].text = ""
			for(var p=0;p<divided.length;p++){
				tree[i].children[p] = tree[i].clone()
				tree[i].children[p].text = divided[p]
			}
			tree[i].type = "variable"
			tree[i].subtype = "array"			
		}

		if(tree[i].inside == "object"){ //One of the children of an object definition
			console.log("-------")
			var objectDivided = divideStatements(tree[i].text,":",false,true,["{","}"])
			if(objectDivided.length==2){ //Inline definition
				delete tree[i].inside
				tree[i].text=""
				console.log(objectDivided)
				tree[i].before = tree[i].clone()
				tree[i].before.text = objectDivided[0]
				tree[i].after = tree[i].clone()
				delete tree[i].after.before //We don't want to copy this too
				tree[i].after.text = objectDivided[1]
				tree[i].type = ":"
			}
		}
		
		//Parse each line with operatorPrecedence() too
		if(tree[i].text!=""){
			var divided = operatorPrecedence(tree[i])
			if(divided.length>1){ //It has been divided
				tree[i] = divided
			}

			//Parse before and after too if it has them
			parseBeforeAfter(tree[i])
		}
	}
	//If they have children, parse them too
	for(var i=0;i<tree.length;i++){
		if(tree[i].children.length != 0){
			tree[i].children=recursiveSyntaxAnalyzer(tree[i].children)
		}
	}
	return tree
}

//We should try to simplify divideStatements() FUTURE
var lastDivider //Needed to now which was the divider that actually divided the string (used operatorPrecedence())
var afterBrackets = false //Needed to know if the string was divided by checkBrackets (used in recursiveSyntaxAnalyzer())
function divideStatements(text,divider,checkBrackets,stopAfterFirst,dontBreakBrackets,notNextTo){
	//Divides a text in the parts with the divider (usually semicolons ;)
	//Text --> string to divide; divider --> character that divides
	//checkBrackets --> if all brackets are closed we divide the string too
	//stopAfterFirst --> stops dividing after the first occurrence of the divider
	//dontBreakBrackets --> Array[2] or false --> doesn't break the string if it involves dividing a bracket listed inside the array
	//notNextTo --> RegExp - characters that shouldn't be before nor after the divider (special characters) Can be undefined
	bracketList = dontBreakBrackets || ["(",")"] //If dontBreakBrackets equals false we don't care about breaking them and we use normal brackets
	afterBrackets = false //Reset it
	var insideDoubleQuoteString = false
	var insideSingleQuoteString = false
	var escapeCharacter = false //True if the last character was a backslash (but not a escaped one)
	var parts = [""] //Array with the divided text
	var index = 0 //Part in which we are
	var openBrackets = 0
	notNextTo = notNextTo || false
	if(divider instanceof Array == false){divider = [divider]}
	outer_loop:
	for(var j =0;j<text.length;j++){
		var addCharacter = true
		var character = text[j]
		if (character=="\\" && (insideDoubleQuoteString == true || insideSingleQuoteString == true)){ //Escape character inside a string
			 escapeCharacter = !escapeCharacter
		}
		
		else{
			
			if (character=='"' && escapeCharacter==false){ //Beginning or ending of a double quoted string
				insideDoubleQuoteString = !insideDoubleQuoteString
			}
			else if (character=="'" && escapeCharacter==false){ //Beginning or ending of a single quoted string
				insideSingleQuoteString = !insideSingleQuoteString
			}
			else if(insideDoubleQuoteString == false && insideSingleQuoteString == false){ //Another statement
				for(var s=0;s<divider.length;s++){
					if(text.substring(j).indexOf(divider[s]) == 0){
						if(dontBreakBrackets == false || (dontBreakBrackets != false && openBrackets == 0)){ //Check that we don't break brackets
							if(notNextTo == false || (j==0 || text[j-1].match(notNextTo) == null) && (j==text.length-1 || text[j+1].match(notNextTo) == null)){
							//Not not followed by or following a notNextTo character
								text = text.substring(0,j) + text.substring(j).replace(divider[s],'') //Erase the divider
								j-- //Need to analyze this character again or it won't be added
								index++ //Next part of the array
								addCharacter = false
								lastDivider = divider[s] //operatorPresence() needs to know this							
								if(stopAfterFirst){
									parts[index] = text.substring(j+1)//The rest of the string
									break outer_loop;	//Break two levels
								}
								else{ parts[index]="" }
							}
						}
					}
			}
			}
			if(character==bracketList[0] && insideDoubleQuoteString == false && insideSingleQuoteString == false){ //One more nested bracket
				openBrackets++
			}
			if(character==bracketList[1] && insideDoubleQuoteString == false && insideSingleQuoteString == false){ //Out of a nested bracket
				openBrackets--
				if(openBrackets==0 && checkBrackets){ //Brackets have ended
					break;
				}
			}
			escapeCharacter = false
		}
		//Add character
		if(addCharacter==true){
			parts[index] += character
		}
	}
	
	if(checkBrackets){
		if(text.substring(j+1)!=""){ //If there is something after we breaked the loop we add it at the end
			afterBrackets = true //Needed in recursiveSyntaxAnalyzer()
			parts.splice(parts.length,0,text.substring(j+1))
		}
	}
	return parts
}

//Add logical not operator ! (using justRight) FUTURE
function operatorPrecedence(node){ //Divides the object taking into account operator precedence, recursion
	if (node.text[0] == "(" && node.text[node.text.length-1] == ")"){ //If the text is inside brackets
		node.text = node.text.substring(1,node.text.length-1) //We erase them
	}
	var dividers = [['+=','-=','*=','/=','%=','^=','.=','='],['||'],['&&'],['==','!='],['<=','>=','<','>'],['+','-'],['*','/'],['--','++']]
	//notNextTo holds the characters that shouldn't be before nor after the divider (special characters)
	var notNextTo = [/[<>\+]/,undefined,undefined,undefined,undefined,/[\+-]/,undefined,undefined] //Undefined means no characters
	var directions = ["right", "left", "left", "left", "left","justBefore"]
	for (var p=0;p<dividers.length;p++){ //Check every precedence
		var divided = divideStatements(node.text,dividers[p],false,true,["(",")"],notNextTo[p])
		if (divided.length > 1){ //Has been divided
			node.before = node.clone()
			node.before.children = [] //We don't want to copy this too
			node.after = node.clone()
			node.after.children = []  //We don't want to copy this too
			node.type = lastDivider //lastDivider was set by divideStatements()
			if(directions[p]=="left"){ //Left to right
				node.after.text = divided[divided.length-1] //Last one
				node.before.text = node.text.substring(0,node.text.lastIndexOf(node.after.text)-lastDivider.length).trim() //The rest
				node.after.text = node.after.text.trim() //Erase blank spaces
			}
			else if(directions[p]=="right"){ //Right to left
				node.before.text = divided[0].trim()
				node.after.text = node.text.replace(node.before.text,'').replace(lastDivider,'').trim()
			}
			else{ //justBefore
				node.before.text = divided[0].trim()
				node.after.text = ""
			}
			if(lastDivider.indexOf('=')!=-1){
				if(node.after.text != "" && node.children.length != 0){ //ERROR 7
					throwError(node.originalLine,7)
				}
				if(node.after.text == ""){ //Indented definition of an object
					node.after.type = "variable"
					node.after.subtype = "object"
					node.after.children = node.children
					for(var l=0;l<node.after.children.length;l++){
						//var objectDivided = divideStatements(node.after.children[l].text,":",false,true,["{","}"])
						//if(objectDivided.length==1) //Inline definition
						node.after.children[l].inside = "object"
					}
				}
			}
			node.text = ""//We don't need this any more
			node.children = [] //We don't need this any more
			node.before = operatorPrecedence(node.before) //Parse both parts
			node.after = operatorPrecedence(node.after)
			return node //Return divided
		}
	}
	delete node.before //Delete this, it was unintentionally copied
	delete node.after //Delete this, it was unintentionally copied
	return node //Hasn't been divided
}

function parseBeforeAfter(node){
	if (node.before != undefined){ //If it has before it should have after too
		if(node.before.before != undefined){ //Before has before and after too
			node.before = parseBeforeAfter(node.before)
		}
		else{
			node.before = recursiveSyntaxAnalyzer([node.before])
		}
		if(node.after.before != undefined){ //After has before and after too
			node.after = parseBeforeAfter(node.after)
		}
		else{
			node.after = recursiveSyntaxAnalyzer([node.after])
		}
		return node
	}
}

function throwError(line,code,data){
var error = "Line "+line+" Error "+code+": "
switch(code){
	case 0:	error+="The keyword for isn't followed by a bracket ("
	break;
	case 1:	error+="The for loop's header has more than three parts (It should have exactly three)"
	break;
	case 2:	error+="The line after a one line for loop can't have a greater indentation"
	break;
	case 3:	error+="The for loop's header has less than three parts (It should have exactly three)"
	break;
	case 4:	error+="The function "+data[0]+" was followed by both an inline definition and a nested definition. Only one of them is allowed."
	break;
	case 5:	error+="An equal sign = was placed with nothing before."
	break;
	case 6:	error+="An equal sign = wasn't followed by anything"
	break;
	case 7:	error+="A variable was followed by both an inline definition and a nested definition. Only one of them is allowed."
	break;
}
error
throwMessage(error)
}

function throwMessage(message){ //Keep this as we might change it in the future
	console.log(message)
}

//We should remove this
Object.prototype.clone = function() {
//Thanks to http://my.opera.com/GreyWyvern/blog/show.dml/1725165
	var newObj = (this instanceof Array) ? [] : {};
	for (i in this) {
		if (i == 'clone') continue;
		if (this[i] && typeof this[i] == "object") {
			newObj[i] = this[i].clone();
		} else newObj[i] = this[i]
  }return newObj;
}

function extractArray(array,index){
	//Extracts an array inside an array 
	for(var o = array[index].length-1;o>-1;o--){
	array.splice(index+1,0,array[index][o])
	}
	array.splice(index,1)
	return array;
}

//Temporal
function keepCode(){
	localStorage["code"]=document.getElementById("codeArea").value
}
function restoreCode(){
	document.getElementById("codeArea").value=localStorage["code"]
}
window.onbeforeunload = keepCode

//https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Operator_Precedence
/*




Regular expresions:
Hexadecimal number:
/^#?([a-f0-9]{6}|[a-f0-9]{3})$/

New line:
/\n+/

*/

//JSON Parser
/*a = getCode()
a = asdf(a)

function asdf(node){
if(node instanceof Array){
for(q =0;q<node.length;q++){
node[q]=asdf(node[q])
}
}
delete node.indentation
delete node.originalLine
for(b in node){
if(node[b] instanceof Array){
for(c =0;c<node[b].length;c++){
node[b][c]=asdf(node[b][c])
}
}
}
return node
}

b = a.clone()*/