function lexer(code){
	var matches = []
	var indentation = 0
	//Add false & true support (before string) LATER
	//Add return support LATER
	var regexArray = [
		/^(["'])(?:\\?.)*?\1/,"literal", 										// String : Thanks to http://blog.stevenlevithan.com/archives/match-quoted-string !
		/^for(?= *\()/,"for", 													// For
		/^while(?= *\()/,"while",												// While
		/^do(?= *\()/,"do",														// Do
		/^\+\+/,"selfOperator",													// ++
		/^--/,"selfOperator",													// --
		/^\+=/,"equality",														// +=
		/^-=/,"equality",														// -=
		/^\*=/,"equality",														// *=
		/^\/=/,"equality",														// /=
		/^%=/,"equality",														// %=
		/^\^=/,"equality",														// ^=
		/^\.=/,"equality",														// .=
		/^\|/,"or",																// &
		/^&/,"and",																// |
		/^==/,"logicalEquality",												// ==
		/^!=/,"logicalEquality",												// !=
		/^<=/,"relational",														// <=
		/^>=/,"relational",														// >=
		/^=/,"equality",														// =
		/^</,"relational",														// <
		/^>/,"relational",														// >
		/^\+/,"firstOperator",													// +
		/^-/,"firstOperator",													// -
		/^\*/,"secondOperator",													// *
		/^\//,"secondOperator",													// /
		/^%/,"secondOperator",													// %
		/^;/,"divider",															// ;
		/^[+-]?([0-9]*\.?[0-9]+|[0-9]+\.?[0-9]*)([eE][+-]?[0-9]+)?/,"literal",	// Number Thanks to http://www.regexlib.com/REDetails.aspx?regexp_id=185
		/^\./,"point",															// .	
		/^\[/,"openSquareBracket",												// [
		/^]/,"closeSquareBracket",												// ]
		/^{/,"openCurlyBracket",												// {
		/^}/,"closeCurlyBracket",												// }
		/^\(/,"openBracket",													// (
		/^\)/,"closeBracket",													// )
		/^:/,"equality",														// :
		/^,/,"comma",															// ,
		/^[A-Za-z]\w*/,"variable"												// Variable
	]

	outerLoop:
	for(g=0;code.length;g++){
		//New line
		if(code.match(/^\s*\n/) != null){
			code = code.replace(/^\s*\n/,"")
			var tabs = code.match(/^\t+/)
			var tabsNum
			if(tabs==null){
				tabsNum = 0 
			}
			else{
				code = code.replace(/^\t*/,"") //Erase those tabs
				tabsNum = tabs[0].length
			}
			var differenceInTabs = tabsNum - indentation
			if(differenceInTabs != 0){ //This line more or less indented as the precedent one
				while(differenceInTabs>0){ //More indentation
					matches[g] = {type:"openCurlyBracket",text:"{"}
					g++
					differenceInTabs--
				}
				while(differenceInTabs<0){ //Less indentation
					matches[g] = {type:"closeCurlyBracket",text:"}"} //Add both a closing bracket and a divider
					g++
					matches[g] = {type:"divider",text:"\n"}
					g++
					differenceInTabs++
				}
				indentation = tabsNum //Save the new line indentation
			}
			else{ //We only count it as a new line if there was no change in the indentation
				matches[g] = {type:"divider",text:"\n"}
				g++
			}
		}

		//Just spaces
		var match = code.match(/^ +/)
 		if(match!=null){
 			code = code.replace(/^ +/,"")
 		}

 		//Try to find the regEx expressions from regexArray
 		for(var i=0;i<regexArray.length;i+=2){
			var match = code.match(regexArray[i])
			if(match!=null){
				matches[g] = {type:regexArray[i+1],text:match[0]}
	 			code = code.replace(regexArray[i],"")
	 			continue outerLoop;
	 		}
		}

 		if(code!=""){ //If there is something that can't be parsed
 			console.log("Error in the lexer. Code that the lexer wasn't able to parse:")
 			console.log(code)
 		}
	}

	//Close every curly bracket that hasn't been closed yet
	for(var b=0;b<indentation;b++){
		matches.push({type:"closeCurlyBracket",text:"}"})
	}
	return matches
}